from matplotlib.pyplot import *
from scipy import *
from numpy import *

# Wykorzystanie algorytmu Rungego-Kutty 4. rzedu
def rungekutta4 (yprime, time, y0):
    # yprime to lista funkcji, y0 to lista wartosci dla y
    # time to lista wartosci t z generowanymi wartosciami

    N = len(time)

    y = array([thing * ones(N) for thing in y0]).T

    for ii in xrange(N - 1):
        dt = time[ii + 1] - time[ii]
        k1 = dt * yprime(y[ii], time[ii])
        k2 = dt * yprime(y[ii] + 0.5 * k1, time[ii] + 0.5 * dt)
        k3 = dt * yprime(y[ii] + 0.5 * k2, time[ii] + 0.5 * dt)
        k4 = dt * yprime(y[ii] + k3, time[ii + 1])
        y[ii + 1] = y[ii] + (k1 + 2.0 * (k2 + k3) + k4) / 6.0

    return y

# warpar - wartosci par
# twar = wartosci czasu
def enrgia(warpar):
    (x, y, px, py) = tuple(warpar)
    return .5 * (px ** 2 + py ** 2) + .5 * (x ** 2 + y ** 2 + 2. * x ** 2. * y - (2.0 / 3) * y ** 3)


def punkt(warpar,twar):
    # zwraca pary (x,y) dla Henona-Heilesa Hamiltonianu
    (x, y, px, py) = tuple(warpar)
    return array([px, py, -x - 2 * x * y, -y - x * x + y * y]).T


def punkt0(data):
    # znajduje indeksy gdzie punkty przecinaja sie w zerze
    p0 = list()
    for ii in xrange(len(data) - 1):
        if (data[ii] > 0) & (data[ii + 1] < 0):
            p0.append(ii)
        if (data[ii] < 0) & (data[ii + 1] > 0):
            p0.append(ii)
    return array(p0)
