#include <iostream>
#include "../headers/symbolic/symbolicc++.h"
using namespace std;

int main(void)
{
  Symbolic h("h"), q1("q1"), q2("q2"), p1("p1"), p2("p2"), pt1, pt2, qt1, qt2;

  // Hamilton function
  h = (p1*p1+p2*p2+q1*q1+q2*q2)/2+q1*q1*q2-q2*q2*q2/3; 
  // Hamilton equations of motion
  pt1 = -df(h,q1); pt2 = -df(h,q2);
  qt1 = df(h,p1);  qt2 = df(h,p2);

  cout << "dp1/dt = " << pt1 <<endl;
  cout << "dp2/dt = " << pt2 <<endl; 
  cout << "dq1/dt = " << qt1 <<endl; 
  cout << "dq2/dt = " << qt2 <<endl;

  return 0;
}

