from matplotlib import pyplot
from scipy import *
from numpy import *

from HenonHeilesHamiltonian import *

t = linspace(0, 100.0, 1000)
print ("Wielkosc kroku " + str(t[1]-t[0]))

# Cztery warunki poczatkowe dla E = 1/12 w ukladzie Henona-Heilesa
init_cons = [array([0.0, 0.5, 0.0, 0.0]),\
             array([0.408248, 0.0, 0.0, 0.0]),\
             array([0.0, 0.0, 0.408248, 0.0]),\
             array([0.0, 0.0, 0.0, 0.408248])\
             ]

outs = list()
for con in init_cons:
    outs.append(rungekutta4(punkt, t, con))

# Rysowanie wynikow
fig1 = figure(1)
for ii in xrange(4):
    subplot(2, 2, ii+1)
    plot(outs[ii][:,1],outs[ii][:,3])
    ylabel("py")
    xlabel("y")
    title("Pelna trajektoria")

fig1.suptitle('Pelna trajektoria przy E = 1/12', fontsize=20)


fig2 = figure(2)
for ii in xrange(4):
    subplot(2, 2, ii+1)
    xcrossings = punkt0(outs[ii][:,0])
    yints = [.5*(outs[ii][cross, 1] + outs[ii][cross+1, 1]) for cross in xcrossings]
    pyints = [.5*(outs[ii][cross, 3] + outs[ii][cross+1, 3]) for cross in xcrossings]
    plot(yints, pyints,'.')
    ylabel("py")
    xlabel("y")
    title("Poincare")

fig2.suptitle('Poincare E = 1/12', fontsize=20)

show()